#include <pic.h>

//  Global Variables
int RTC = 0;					//  Real Time Clock Counter

volatile char LCDDlay = 20;			//  Initialization Delay Value
volatile char LCDState = 1;			//  Current LCD State

static volatile bit Clock     @ (unsigned)&PORTB*8+1;
static volatile bit ClockTRIS @ (unsigned)&TRISB*8+1;
static volatile bit Data      @ (unsigned)&PORTB*8+2;
static volatile bit DataTRIS  @ (unsigned)&TRISB*8+2;

static volatile bit Clk_AD      @ (unsigned)&PORTA*8+3;
static volatile bit Data_AD     @ (unsigned)&PORTA*8+2;

static volatile bit CS_AD      @ (unsigned)&PORTA*8+1;
static volatile bit Dat_ACP      @ (unsigned)&PORTA*8+4;
//static volatile bit DatTRIS_ACP  @ (unsigned)&TRISB*8+6;
static volatile bit CLK_ACP      @ (unsigned)&PORTB*8+0;
//static volatile bit  CLK_TRIS_ACP  @ (unsigned)&TRISB*8+0;
static volatile bit CS_ACP      @ (unsigned)&PORTB*8+3;
//static volatile bit  CS_TRIS_ACP  @ (unsigned)&TRISB*8+0;

char * MessageOut;				//  Message to be Sent Out
volatile char MessageOuti = 0;			//  Index to current Message Byte
volatile char ButtonPress = 0;
volatile char ButtonPress1 = 0;

char Message1[18] = "\376\200sound - 0x0xxxx";	//  Message when sound
//                   1   2   3456789012345678
char Message2[18] = "\376\200               ";	//  Message when nothing

//char soundCounter = 20;			//  Wait 20 msecs for Sound Check
int OldTMR1 = 0;				//  Timer Values
int CurrentTMR1;

//unsigned int i,Rez_ACP;
//unsigned int dat[10];
// bank1 unsigned char ij;
 bank1 unsigned short dat[10];
 bank1 int Rez_ACP,i;
 
 
  bank1 unsigned int tempp;
 
  bank1 unsigned int dummy;
  unsigned int i_byt;
  bank1 unsigned int weight;

bank1 int res,ress;
//unsigned int ii, jj;
unsigned int tempLeft, tempRight=8;

  bank1 char returnValue;

volatile char soundState = 0;		//  Sound State Variable
char temp;
int  TMR1Value;
//  Configuration Fuses
#if defined(_16F627)
#warning PIC16F627 with external XT oscillator selected
	__CONFIG(0x03F70);		//  PIC116F627 Configuration Fuses:
					
#else
#error Unsupported PICmicro MCU selected
#endif

//int i=0;

//***********************************************

Dlay(int msecs)				//  Delay Specified Number of msecs
{

volatile int variableDlay;		//  1 Second Delay Variable

	variableDlay = RTC + msecs + 1;	//  Get the End Time
	while (variableDlay != RTC);

}  //  End Dlay

//***********************************************
LCDNybble(char Nybble, char RS) { 		//  Send Nybble to LCD

unsigned int i; 

	Data = 0; // Clear the '174 
	for (i = 0; i < 6; i++) { 		// Repeat for six bits 
		Clock = 1; Clock = 0; 		// Write the "0"s into the '174 
	}   //  endfor 

	Data = 1; 				// Output the "AND" Value 
	Clock = 1; Clock = 0; 

	Data = RS; 				// Output the RS Bit Value 
	Clock = 1; Clock = 0; 

	for (i = 0; i < 4; i++) { 		// Output the Nybble 
		if ((Nybble & 0x008) != 0) 
			Data = 1; 		// Output the High Order Bit 
		else 
			Data = 0; 
		Clock = 1; Clock = 0; 		// Strobe the Clock 
		Nybble = Nybble << 1; 		// Shift up Nybble for Next Byte 
	}  //  endfor

	Data = 1; Data = 0; 			// Toggle the "E" Clock Bit 

}  //  End LCDNybble 

LCDByte(char Byte, char RS) {	 		//  Send Byteto LCD

	LCDNybble((Byte >> 4) & 0x00F, RS);	//  Send High Nybble
	LCDNybble(Byte & 0x00F, RS);		//  Send Low Nybble

}  //  End LCDByte


LCDInit()					//  Initialize the LCD I/O Pins
{

	Clock = 0; Data = 0;			//  Low I/O Bits
	ClockTRIS = 0; DataTRIS = 0;

}  //  End LCDInit
//***********************************************

LCDOut(char * const LCDString)	//  Output the Data String
{

	while (LCDState);		//  Wait for LCD Available

	MessageOut = LCDString;		//  Load up the string
	LCDState = 100;			//  Start Sending the String

}  //  End LCDOut

//***********************************************

//  Interrupt Handler
void interrupt tmr0_int(void)			//  TMR0 Interrupt Handler
	{
	if (T0IF)
	 {
		T0IF = 0;			//  Reset Interrupt Flag
	RTC++;				//  Increment the Clock

//////////////////////////////////////////////
//  Increment Counter if Button Pressed

		if (!RB4) 			//  Button Pressed
			if (ButtonPress < 20)	//  Button Press being debounced
				ButtonPress++;
			else;			//  Button Pressed for 20 msecs
		else				//  Button Released
			if (ButtonPress != 0)	//  Button Release being debounced
				ButtonPress--;
			else;			//  Button released for more than 20 msecs
			
	///////////////////////////////////////////////		
			//  Increment Counter if Button Pressed

		if (!RB5) 			//  Button Pressed
			if (ButtonPress1 < 20)	//  Button Press being debounced
				ButtonPress1++;
			else;			//  Button Pressed for 20 msecs
		else				//  Button Released
			if (ButtonPress1 != 0)	//  Button Release being debounced
				ButtonPress1--;
			else;			//  Button released for more than 20 msecs
			
		///////////////////////////////////
			
//  LCD State Machine

		switch(LCDState) {			//  Process the State Machine information
			case 1:				//  Start LCD Initialization Process
				if (--LCDDlay == 0)
					LCDState++;
				break;			//  Wait 20 msecs for LCD to reset
			case 2:				//
				LCDNybble(0x003, 0);	//  Step 2 - Send Init Char
				LCDDlay = 5;
				LCDState++;
			case 3:				//  Wait for Command to Complete
				if (--LCDDlay == 0)
					LCDState++;
				break;
			case 4:
				LCDNybble(0x003, 0);	//  Step 3 - Send Init Char
				LCDState++;
				break;
			case 5:
				LCDNybble(0x003, 0);	//  Step 4 - Send Init Char
				LCDState++;
				break;
			case 6:
				LCDNybble(0x002, 0);	//  Step 5 - Set Operating
				LCDState++;		//   Interface Size (4 Bits)
				break;
			case 7:
				LCDByte(0x028, 0);	//  Step 6 - Set Operating
				LCDState++;			
				break;
			case 8:
				LCDByte(0x008, 0);	//  Step 7 - Display Off
				LCDState++;			
				break;
			case 9:
				LCDByte(0x001, 0);	//  Step 8 - Clear Display
				LCDState++;			
				LCDDlay = 5;		//  Wait 5 msecs for Clear to Complete
				break;
			case 10:			//  Wait for Command to Complete
				if (--LCDDlay == 0)
					LCDState++;
				break;
			case 11:
				LCDByte(0x006, 0);	//  Step 9 - Shift 
				LCDState++;			
				break;
			case 12:
				LCDByte(0x00E, 0);	//  Step 10 - Display On
				LCDState = 0;		//  Ready to Run
				break;

			case 100:				//  Output a Character in "MessageOut"
				switch (temp = MessageOut[MessageOuti++]) {
					case '\0':		//  At the End of the Message
						LCDState = 0;
						MessageOuti = 0;	//  Reset Message Index
						break;
					case '\f':		//  Clear Display
						LCDByte(0x001, 0);
						LCDState++;
						LCDDlay = 5;
						break;
					case 254:		//  Command Byte follows
						if ((temp = MessageOut[MessageOuti++]) == 0)
							LCDState = 0;
						else {
							if (temp < 4) {
								LCDState++;
								LCDDlay = 5;
							}  //  endif
							LCDByte(temp, 0);
						}  //  endif
						break;
					default:		//  All other characters
						LCDByte(temp, 1);
				}  //  endswitch
				break;
			case 101:				//  Message Delay
				if (--LCDDlay == 0)
					LCDState--;
				break;
		}  //  endswitch

	}  //  endif

//  Put Different Interrupt Handlers here

}  //  End Interrupt Handler


//****************   *******************************
unsigned int ACP(){

 
	CS_ACP=0;
 for (i=1; i<=10; i++) {

   CLK_ACP=0;
   CLK_ACP=1; 
   dat[i]=Dat_ACP;
   CLK_ACP=0;}   

        Rez_ACP=(512*dat[1] + 256*dat[2] +128*dat[3] + 64*dat[4]
        + 32*dat[5] + 16*dat[6] +8*dat[7] + 4*dat[8]
         + 2*dat[9]+1*dat[10]);
CS_ACP=1;
         return Rez_ACP; }

//***********************************************

//  Subroutines
char GetHex(char Value)
{

	if (Value > 9)
		returnValue = Value + 'A' - 10;
	else
		returnValue = Value + '0';

	return returnValue;

}  //  End GetHex

 ///	(********** Potenciometr  AD5231*********************)
void AD10(int byt){

   Clk_AD=0;     // ClK=0
   Data_AD=0;    // DQ=0
   Data_AD=byt;  // DQ= BYT
   Clk_AD=1;     // ClK=1
   Clk_AD=0;     // ClK=0
   Data_AD=0;}   // DQ=0


//(**********************************)
unsigned int Bit_weight(int bytn){


switch (bytn){
  case 1:    weight=1;	break;
  case 2:    weight=2;	break;
  case 3:    weight=4;	break;
  case 4:    weight=8;	break;
  case 5:    weight=16;	break;
  case 6:    weight=32;	break;
  case 7:    weight=64;	break;
  case 8:    weight=128;	break;
  case 9:    weight=256;	break;
  case 10:   weight=512;	break;}
             return weight;}

 //(**********************************)

void potenc(int bytt){ 

   AD10(1);
   AD10(0);
   AD10(1);
   AD10(1);
   
      for (i=10; i>0; i--) {AD10(0);}
	     
		for (i=10; i>0; i--) {
					  
        tempp=( bytt & Bit_weight(i));
	         if  (tempp>0) tempp=1;
                                 
	      AD10(tempp); }}

  
  
//***********************************************

//  Mainline
void main(void){					//  Template Mainline

	OPTION = 0x0d1;				//  Assign Prescaler to TMR0
   TMR0 = 0;				//  Reset the Timer for Start
	T0IE = 1;				//  Enable Timer Interrupts
	GIE = 1;				//  Enable Interrupts
	
	CMCON=0x007;
   VRCON=0;		

TRISB5=1;TRISB4=1;TRISB3=0;TRISB0=0;
	LCDInit();				//  Initialize the LCD Port

	T1CON = 0x003;			//  1:1 Prescaler
						//  T1OSCEN Off
						//  _T1SYNC Active
						//  TMR1CS is Exteral Clock
						//  TMR1ON
 TRISA=16;
// TRISB=0;
 
 
	while (1 == 1) {			//  Loop forever
		
//////////////////////////////////////////////////
	//  Put in Robot high level operation code here

	if(ButtonPress==20)res++;
		if(ButtonPress1==20)res--;	
	
	CS_AD=0;
   potenc(res); 
 
  Data_AD=0;  // DQ= BYT
   Clk_AD=0;     // ClK=1
  CS_AD=1;     // CS=1
  
//////////////////////////////////////////
ress=ACP();
	
CurrentTMR1 = ress;
		Message1[13] = GetHex((CurrentTMR1 & 0x0F000) >> 12);
		Message1[14] = GetHex((CurrentTMR1 & 0x0F00) >> 8);
		Message1[15] = GetHex((CurrentTMR1 & 0x0F0) >> 4);
		Message1[16] = GetHex(CurrentTMR1 & 0x0F);

		LCDOut(Message1);		//  Indicate "Sound"
Dlay(30);


		LCDOut(Message2);		//  Clear the Sound Message

///////////////////////


  
	}  //  endwhile

}  //  End of Mainline
